// DicksBackupView.h : interface of the CDicksBackupView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_DICKSBACKUPVIEW_H__F42EC4D3_805C_4891_8151_6D6113E2E2E2__INCLUDED_)
#define AFX_DICKSBACKUPVIEW_H__F42EC4D3_805C_4891_8151_6D6113E2E2E2__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


class CDicksBackupView : public CListView
{
protected: // create from serialization only
	CDicksBackupView();
	DECLARE_DYNCREATE(CDicksBackupView)

// Attributes
public:
	CDicksBackupDoc* GetDocument();
	CTypedPtrArray<CPtrArray, CHdrExtraData *> m_hdrExtraDataPtrArray;

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDicksBackupView)
	public:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual void OnInitialUpdate(); // called first time after construct
	protected:
	//}}AFX_VIRTUAL

// Implementation
public:
	UINT m_nDateFmt;
	UINT GetColumns();
	CListCtrl * m_pListCtrl;
	UINT GetRows();
	void RefreshEntireList();
	void UpdateRow(UINT item);
	virtual ~CDicksBackupView();
	void AppendItemToList(CItemData * pItemData);
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	UINT m_autoBackupTimeHours;
	BOOL m_bShowIcons;
	void CreateImageList();
	CImageList * m_pImageList;
	BOOL m_bAutoBackup;
	BOOL m_bGrayBar;
	void SetFont(int fontPtSize);
	CFont * m_pFont;
	int m_fontPtSize;
	CDicksBackupDoc * m_pDoc;
	//{{AFX_MSG(CDicksBackupView)
	afx_msg void OnDestroy();
	afx_msg void OnColumnclick(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnEditRemove();
	afx_msg void OnUpdateEditRemove(CCmdUI* pCmdUI);
	afx_msg void OnViewReset();
	afx_msg void OnEditSelectNone();
	afx_msg void OnUpdateEditSelectNone(CCmdUI* pCmdUI);
	afx_msg void OnEditNote();
	afx_msg void OnUpdateEditNote(CCmdUI* pCmdUI);
	afx_msg void OnContextMenu(CWnd* pWnd, CPoint point);
	afx_msg void OnViewGrayBar();
	afx_msg void OnUpdateViewGrayBar(CCmdUI* pCmdUI);
	afx_msg void OnViewAutoBackup();
	afx_msg void OnUpdateViewAutoBackup(CCmdUI* pCmdUI);
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);
	afx_msg void OnViewShowIcons();
	afx_msg void OnUpdateViewShowIcons(CCmdUI* pCmdUI);
	afx_msg void OnChangeDrive();
	afx_msg void OnUpdateChangeDrive(CCmdUI* pCmdUI);
	afx_msg void OnEditSelAll();
	afx_msg void OnUpdateEditSelAll(CCmdUI* pCmdUI);
	afx_msg void OnEditMoveArchivePath();
	afx_msg void OnUpdateEditMoveArchivePath(CCmdUI* pCmdUI);
	afx_msg void OnEditDuplicate();
	afx_msg void OnUpdateEditDuplicate(CCmdUI* pCmdUI);
	afx_msg void OnEditRestore();
	afx_msg void OnUpdateEditRestore(CCmdUI* pCmdUI);
	afx_msg void OnHelpDoc();
	afx_msg void OnEditOpenSource();
	afx_msg void OnUpdateEditOpenSource(CCmdUI* pCmdUI);
	//}}AFX_MSG
	afx_msg void OnCustomDraw(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnShowCol(UINT nID);
	afx_msg void OnUpdateShowCol(CCmdUI* pCmdUI);
	afx_msg void OnChangeDate(UINT nID);
	afx_msg void OnUpdateChangeDate(CCmdUI* pCmdUI);
	afx_msg void OnUpdateNumFiles(CCmdUI* pCmdUI); 
	afx_msg void OnUpdateNumBytes(CCmdUI* pCmdUI); 
	afx_msg void OnChangeFont(UINT nID);
	afx_msg void OnUpdateChangeFont(CCmdUI* pCmdUI);
	afx_msg void OnEditExplorer(UINT nID);
	afx_msg void OnUpdateEditExplorer(CCmdUI* pCmdUI);
	DECLARE_MESSAGE_MAP()
	afx_msg void OnUpdateNumObselete(CCmdUI* pCmdUI); 
	afx_msg void OnUpdateNumProblems(CCmdUI* pCmdUI); 
};

#ifndef _DEBUG  // debug version in DicksBackupView.cpp
inline CDicksBackupDoc* CDicksBackupView::GetDocument()
   { return (CDicksBackupDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DICKSBACKUPVIEW_H__F42EC4D3_805C_4891_8151_6D6113E2E2E2__INCLUDED_)
