// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "MyIncludes.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_WM_DESTROY()
	ON_WM_ENDSESSION()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
//	ID_INDICATOR_CAPS,
//	ID_INDICATOR_NUM,
//	ID_INDICATOR_SCRL,
    ID_INDICATOR_NUM_PROBLEMS,
    ID_INDICATOR_NUM_OBSELETE,
	ID_INDICATOR_NUM_FILES,
	ID_INDICATOR_NUM_BYTES,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	m_bFirstTime = TRUE;
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	// get initial font size so we can match toolbar icon size
	UINT fontPtSize = AfxGetApp()->GetProfileInt(settings, nFontPtSize, DFLT_FONT_PT_SIZE);
	int indexTB = (fontPtSize - 10) / 5;
	ASSERT(indexTB >= 0 && indexTB < 3); // must be 10, 15, or 20 point font

	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(_toolBarID[indexTB]))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	// TODO: Delete these three lines if you don't want the toolbar to
	//  be dockable
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers


void CMainFrame::ActivateFrame(int nCmdShow) 
{
	if (m_bFirstTime) // do just one time at initilial startup
	{
		m_bFirstTime = FALSE;
	
		CString strText; // main window position
		strText = AfxGetApp()->GetProfileString(s_profileHeading, s_profileRect, NULL);

		CRect rect(0, 0, 0, 0);

		// get window position from registry
		if (!strText.IsEmpty() && 4 == sscanf(strText, _T("%d %d %d %d"), &rect.left, &rect.top, &rect.right, &rect.bottom)) 
		{
			BOOL bMaximized = AfxGetApp()->GetProfileInt(s_profileHeading, s_profileMax, 0); 
			UINT flags = bMaximized ? WPF_RESTORETOMAXIMIZED : WPF_SETMINPOSITION;

			BOOL bIconic = AfxGetApp()->GetProfileInt(s_profileHeading, s_profileIcon, 0);
			if (bIconic) 
			{
				nCmdShow = SW_SHOWMINNOACTIVE;
			}
			else
			{
				nCmdShow = bMaximized ? SW_SHOWMAXIMIZED : SW_NORMAL;
			}

			WINDOWPLACEMENT wndpl;
			wndpl.length = sizeof(WINDOWPLACEMENT);
			wndpl.showCmd = nCmdShow;
			wndpl.flags = flags;
			wndpl.ptMinPosition = CPoint(0, 0);
			wndpl.ptMaxPosition = CPoint(-::GetSystemMetrics(SM_CXBORDER), -::GetSystemMetrics(SM_CYBORDER));
			wndpl.rcNormalPosition = rect;
			LoadBarState(AfxGetApp()->m_pszProfileName);
			// sets window's position and minimized/maximized status
			SetWindowPlacement(&wndpl);

			return;
		}
	}
	
	CFrameWnd::ActivateFrame(nCmdShow);
}

void CMainFrame::OnDestroy() 
{
	CString strText;
	BOOL bIconic, bMaximized;

	WINDOWPLACEMENT wndpl;
	wndpl.length = sizeof(WINDOWPLACEMENT);
	// gets current window position and
	//  iconized/maximized status
	BOOL bRet = GetWindowPlacement(&wndpl);
	if (wndpl.showCmd == SW_SHOWNORMAL) 
	{
		bIconic = FALSE;
		bMaximized = FALSE;
	}
	else if (wndpl.showCmd == SW_SHOWMAXIMIZED) 
	{
		bIconic = FALSE;
		bMaximized = TRUE;
	} 
	else if (wndpl.showCmd == SW_SHOWMINIMIZED) 
	{
		bIconic = TRUE;
		if (wndpl.flags) 
		{
			bMaximized = TRUE;
		}
		else 
		{
			bMaximized = FALSE;
		}
	}
	// main window location
	strText.Format("%04d %04d %04d %04d",
	               wndpl.rcNormalPosition.left,
	               wndpl.rcNormalPosition.top,
	               wndpl.rcNormalPosition.right,
	               wndpl.rcNormalPosition.bottom);
	AfxGetApp()->WriteProfileString(s_profileHeading, s_profileRect, strText);

	AfxGetApp()->WriteProfileInt(s_profileHeading,
	                             s_profileIcon, bIconic);
	AfxGetApp()->WriteProfileInt(s_profileHeading,
	                             s_profileMax, bMaximized);
	SaveBarState(AfxGetApp()->m_pszProfileName);
	
	CFrameWnd::OnDestroy();
}

void CMainFrame::SetToolBarSize(int index)
{
	m_wndToolBar.LoadToolBar(_toolBarID[index]);

	// toggle toolbar on-off if it is showing to force a change in its height
	if((m_wndToolBar.GetStyle() & WS_VISIBLE) == WS_VISIBLE)
	{
		// toggle on and off
		ShowControlBar(&m_wndToolBar, FALSE, TRUE);	
		ShowControlBar(&m_wndToolBar, TRUE, TRUE);
	}
}

void CMainFrame::OnEndSession(BOOL bEnding) 
{
	if(bEnding)
	{
		CDicksBackupDoc * pDoc = (CDicksBackupDoc *)(GetActiveView()->GetDocument());
		pDoc->OnSaveDocument(pDoc->GetPathName());
	}

	CFrameWnd::OnEndSession(bEnding);
}
